<?php
/****************************************************************************\
* phpCDLabelPS                                   (c) 2002 by Itzchak Rehberg *
* -------------------------------------------------------------------------- *
* Reads in data disks and creates CDLabels based on that information and a   *
* given template, output will be a PostScript Level 2 file. License: GPL     *
* -------------------------------------------------------------------------- *
* This file actually creates the output. Make sure it gets the right para-   *
* meters via URL or HTTP POST/GET, which are:                                *
* $source - the URL the medium is mounted to                                 *
* $title  - the title (name) of the CD                                       *
* $title_font_size / $text_font_size - font sizes for dirs/files             *
\****************************************************************************/

/* $Id: labelgen.inc,v 1.3 2002/05/15 22:08:03 izzy Exp $ */

$dir    = $source;
#$maxlen = 150; # maximum line length on cover
#$maxlen = ceil( ( ($cover_width - 2 * $cover_side) * 3 ) / ($text_font_size * 2) );
$maxlen = ceil( 587 / $text_font_size );

##############################################################################
# get a directory listing
function listFiles($dir, $type) { 
 if (strlen($type) == 0) $type = "all"; 
 if(is_dir($dir))  { 
   $thisdir = dir($dir); 
   while($entry=$thisdir->read()) {
     if(($entry!='.')&&($entry!='..')) {
       switch ($type) {
         case "all"   : $result[] = $entry; break;
	 case "files" : if (is_file("$dir/$entry")) $result[] = $entry; break;
	 case "dir"   : if (is_dir("$dir/$entry")) $result[] = $entry; break;
	 default      : break;
       }
     }
   } 
 } 
 return $result; 
}

##############################################################################
# print a directory name as title
function printTitle($title,$level) {
 for ($i=0;$i<$level;$i++) { $title = " " . $title; }
 echo "title_font title_font_size selectfont\n"
    . "pos_x pos_y title_font_size sub moveto\n"
    . "($title) show\n"
    . "/pos_y pos_y title_font_size 1.1 mul sub def\n";
}

##############################################################################
# print a line of content text
function printLine($text) {
 echo "text_font text_font_size selectfont\n"
    . "pos_x pos_y text_font_size sub moveto\n"
    . "($text) show\n"
    . "/pos_y pos_y text_font_size 1.1 mul sub def\n";
}

##############################################################################
# prepare the filelist of one directory for output
function makeList($content,$level) {
 if (!$content) return; // nothing to print
 GLOBAL $maxlen;
 $outline = "";
 for ($i=0;$i<$level;$i++) {
   $outline .= " ";
 }
 $i = 0;
 while ( $i<count($content) ) {
   if ( strlen($outline)+strlen($content[$i])<$maxlen ) {
     $outline .= " ./. $content[$i]";
   } else {
     printLine($outline);
     $outline = "";
     for ($k=0;$k<$level;$k++) {
       $outline .= " ";
     }
     $outline .= $content[$i];
   }
   ++$i;
 }
 printLine($outline);
}

##############################################################################
# loop through the directories
function loopDir($dir,$level) {
  GLOBAL $subtype,$maxlevel;
  $dirlist  = listFiles($dir,"dir");
  for ($i=0;$i<count($dirlist);$i++) {
    $subdir   = $dirlist[$i];
    printTitle($subdir,$level);
    $filelist = listFiles("$dir/$subdir","$subtype");
    makeList($filelist,$level);
    if ($level<$maxlevel) {
      loopDir("$dir/$subdir/",$level +1);
    }
  }
}

##############################################################################
# create the output (.ps file)
    // Send header information.
#    header("Content-Type: text/plain");
    header("Content-Type: application/postscript");
    header( "Content-Disposition: attachment; filename=\"".$title.".ps\"");
    
    // Load Postscript template.
    $template = file("cdtemplate.ps");

    for ($i=0;$i<count($template);$i++) {
      $template[$i] = str_replace("[%title%]","($title)",$template[$i]);
      $template[$i] = str_replace("[%title_font_size%]","$title_font_size",$template[$i]);
      $template[$i] = str_replace("[%text_font_size%]","$text_font_size",$template[$i]);
      echo $template[$i];
    }

# Root directory
$filelist = listFiles($dir,"$roottype");
makeList($filelist,0);

if ($maxlevel) loopDir($dir,1);
?>
